;-----------------------------;
; ASSM_MX/4K - SP_580 RAMFOS  ;
;-----------------------------;
; p p p________________________
;  E9AD LXI  H,0009;  p  EDIT
;  E9B0 PUSH H
;  E9B1 CALL EA54
;  E9B4 LHLD 1087  ; p  pp p
;  E9B7 XCHG
;  E9B8 LXI  H,F000; p    p
;  E9BB STA  FFFE
;  E9BE RET;         JMP  0009  ROM

;  0009 JMP  0017;   pp ROM __________________

;  0012 CALL 0051
;  0015 POP  H
;  0016 RET

;  0017 PUSH H; F000 p    p
;  0018 XCHG; [DE] - p ; [HL]- pp
;  0019 PUSH H;    - p  pp p
;  001A LXI  H,1800
;  001D JMP  0012

;  0051 LXI  B,07FF
;  0054 MOV  A,M
;  0055 STAX D;    - p ;
;  0056 MOV  A,B
;  0057 ORA  C
;  0058 RZ;        -  p  p p
;  0059 INX  H
;  005A INX  D
;  005B DCX  B
;  005C JMP  0054

        ORG  0F000H; -    0F000H;

        STA  ZAK;  p  ROM - p 
        INX  H;
        SHLD BHL
STR:
        LXI  H,KB1; "ASSM_MX/4K:..."
        CALL LNS

        LHLD BHL
        MOV  M,A; A = 0
        STA  PRZ

        MOV  H,A
        MOV  L,A
        SHLD BRG

        INR  A;  A = 1
        STA  FLG

        CALL KBD
        CPI  1FH; STR
        JZ   EXIT
        STA  KEY
        CPI  03H; F4 -   
        JP   STR; p  

        DCR  A;   02H = F3: 02H-1=01H  - Z
        JNZ  ASM; F3 - EXE
        DCR  A;   01H - 1 = 00H
        STA  ERR
        CALL FIL; p  LIN
        XCHG
        SHLD ELN
        LHLD BHL
        DCX  H
        CALL CMHLDE
        JNZ  K52

        LXI  H,KB1; "ASSM_MX/4K:..."
        CALL LNS
ASM:
        LXI  H,BUF
        SHLD BBF
        LXI  H,BEG; 0000H
        SHLD FIN
        XRA  A
        STA  ERR
NEXT:
        XRA  A
        STA  CER
        STA  BA2

        LHLD FIN;
        SHLD BFN

        LXI  SP,STK
        CALL GAN;     p
;                    p  p  0DH
        LXI  H,SBF; 1066H
        MOV  A,M
        CPI  3BH; ';'
        JZ   TBFRET

        CALL TO_CMD
        CPI  3AH; ':'
        JNZ  K45
        XRA  A
        CMP  C
        JZ   K46

        PUSH H
        LDA  KEY
        DCR  A
        CZ   ITEQU
        CALL K6E
        POP  H

        CALL MIMO20
        ORA  A
        JZ   TBFRET

        CPI  3BH; ';'
        JZ   TBFRET
        CALL TO_CMD
K45:
        PUSH H
        CALL ANACOD
        POP  H
        CALL ANLARG

        PUSH H
        LXI  H,TB0;   TB0
        LDA  OFS
        MOV  E,A
        MVI  D,00H; DE = 00.OFS
        DAD  D
        DAD  D;     HL = TB0+OFS*2
        MOV  E,M
        INX  H
        MOV  A,M
        CMP  C;    KOP
        JNZ  K62

        LXI  H,TBFUNK
        DAD  D;   HL=TBFUNK+DE
        LXI  D,TBFRET
        XCHG;     HL=TBFRET; DE=TBFUNK+DE
        XTHL;    [SP]=HL=TBFRET;
        PUSH D;  [SP+1]=TBFUNK+DE
        LDA  RG8
        RET;  -  JMP TBFUNK+DE
K46:
        MVI  B,10H
K47:
        CALL SETERR
TBFRET:;___  p   
        CALL KA0
        LXI  H,1001H; -  
        XCHG;  DE = 1001H   - 4K.
        LHLD FIN
        CALL TSTMEM
        CALL KLA
        CPI  1FH; STR
        JNZ  NEXT
        JMP  EXIT;-------------------------------
ITEQU:
        CALL MIMO20
        MOV  A,M
        CPI  45H; 'E'
        RNZ
        INX  H
        MOV  A,M
        CPI  51H; 'Q'
        RNZ
        STA  BA2; 'Q'-EQU
        RET

TBFUNK:
;_______ _____
        ORI  40H; RG*8 OR 0100.0000b
        STA  KOP
        CALL K7B
TBF08H:
        LDA  RGN
TBF0BH:
        JMP  KOPREG
TBF0EH:
        ORI  06H; RG*8 OR 0000.0110b
        STA  KOP
        CALL K7B
TBF16H:
        MVI  C,01H
        JMP  KODMEM
TBF1BH:
        CALL K5A
        ORI  01H; 0000.0001b
        STA  KOP
        CALL K7B
TBF26H:
        MVI  C,02H
        JMP  KODMEM
TBF2BH:
        CALL K5A
        JMP  KOPREG
TBF31H:
        CALL K5C
        JMP  KOPREG
TBF37H:
        CALL K5E
        JMP  KOPREG
TBF3DH:
        LDA  RGN; [105AH]
        MOV  B,A
        ANI  07H; 0000.0111b
        CMP  B
        JNZ  K62;   pp
        RLC; * 2
        RLC; * 4
        RLC; * 8
        JMP  KOPREG
TBF4DH:
        LHLD FIN
        XCHG
        LHLD RGN
        DAD  D
        SHLD FIN
        RET
TBF59H:
        LXI  H,SBF
        CALL TO_CMD
        CPI  3AH; ':' 60
        JNZ  K46
        LHLD RGN
        SHLD BFN
        XCHG
        LDA  FLG
        DCR  A
        RNZ;          6F
        LDA  CER
        DCR  A
        RZ
        JM   K50
        LXI  D,0FFFEH; ROM
K4B:
        LHLD BDE; [105DH]
        MOV  M,E
        INX  H
        MOV  M,D
        RET
TBF82H:
        XCHG
        LHLD FIN
        LDAX D
        CPI  27H; [']
        JNZ  K4E
        INX  D
K4D:
        LDAX D
        INX  D
        ORA  A;  8F
        JZ   K62
        CPI  27H; [']
        JZ   K4F
        MOV  M,A
        INX  H
        JMP  K4D; 9C
K4E:
        LDA  RGN
        MOV  M,A; A0
        INX  H
        LDA  OFS
        CPI  0EH
        JZ   K4F
        LDA  RG8
        MOV  M,A
        INX  H;  AE
K4F:
        SHLD FIN
        XCHG;    B2
        CALL MIMO20
        ORA  A;    0
        RZ
        CPI  3BH; ';'
        RZ
        CALL K7B
        JMP  TBF82H
TBFC1H:
        LDA  PRZ
        ORA  A
        RNZ
        INR  A
        STA  PRZ
        LHLD RGN
        SHLD BRG
        RET; D0
K50:
        LDA  BA2
        ORA  A
        RNZ
        JMP  K4B
TBFD9H:
K51:
        CALL KA0
        LXI  H,FLG
        DCR  M
        JZ   ASM

        LHLD FIN
        DCX  H;   HL -  
        XCHG;     DE = HL
        LHLD BRG
        DAD  D
        CALL PSSCR
K52:
        MVI  C,2FH; '/'
        CALL HLHEX
        XCHG
        CALL HLHEX

        LXI  H,KB0; ':'
        CALL LNS

        LDA  ERR
        CALL HEK;    
        ORA  A
        JNZ  STR

        LXI  H,LIN; pp
        CALL EXT
        LHLD ELN;   p 
        XCHG
        LHLD BHL;   p 
        DCX  H
        CALL SAV;   p 

        LXI  H,EXE; pp
        CALL EXT
        LHLD FIN;   p 
        DCX  H
        XCHG
        LXI  H,BEG; p 
        CALL SAV;   p 
EXIT:
        LHLD BHL
        DCX  H
        JMP  EDT; 0E806H - EDIT
PSSCR:
        MVI  A,0AH
        CALL SCA
        RNZ
        LXI  B,0320H
SPB:
        DCR  B;  B * ' '(Space)
        RM
        CALL SCR; C -> p
        JMP  SPB

KOPREG:
        MOV  B,A
        LDA  KOP
        ORA  B
        LHLD FIN
KOPMEM:
        MOV  M,A
        INX  H
INXMEM:
        SHLD FIN
        RET
KODMEM:;_____________ C- 
        LHLD RGN
        XCHG; DE = RGN
        LHLD FIN
        LDA  KOP
        MOV  M,A
        INX  H
        MOV  M,E
        INX  H
        DCR  C
        JZ   INXMEM
        MOV  A,D
        JMP  KOPMEM
K5A:
        CPI  40H; '@'
K5B:
        JNZ  K5D
        MVI  A,30H; '0'
        RET
K5C:
        CPI  48H; 'H'
        JMP  K5B
K5D:
        CPI  20H; ' '
        RZ
K5E:
        CPI  10H; ''
        RZ

        ORA  A
        JNZ  K62
        RET
SETER1:
        MVI  B,01H; p 
        JMP  SETERR
SETER2:
        MVI  B,02H;   
        LXI  D,0FFFEH; ROM
SETERR:
        PUSH H
        LXI  H,CER
        MOV  A,M
        ORA  B
        MOV  M,A
        LXI  H,ERR
        MOV  A,M
        INR  A
        DAA
        MOV  M,A
        POP  H
        RET
K62:
        MVI  B,08H
        JMP  K47

GAN:;_______p  p 
        LXI  D,SBF; p p
        MVI  C,7FH;  p 127 
        LHLD BBF; .p.p.
ANL:
        MOV  A,M
        INX  H
        CPI  0FFH;'.'
        JZ   K51
        CPI  0DH; ''
        JZ   BKK
        CPI  09H; 'Tab'
        JNZ  PSK
        MVI  A,20H
        PUSH H
        MVI  H,03H
TAB:
        STAX D
        INX  D
        DCR  C
        DCR  H
        JNZ  TAB
        POP  H
PSK:
        CPI  0AH; ''
        JZ   ANL
        STAX D
        DCR  C
        JM   ANL
        INX  D
        JMP  ANL
BKK:
        XRA  A
        STAX D
        MOV  A,C
        CPI  7FH; 127 ?
        JZ   ANL
        SHLD BBF; .p.p.
        RET
TO_CMD:
        MVI  C,06H;  p
        LXI  D,CMD;  
        PUSH D
        MVI  A,20H
CLRCMD:
        STAX D; - [A]  .
        INX  D
        DCR  C;  .-1
        JNZ  CLRCMD
        POP  D
        CALL MIMO20
TSTLAT:
        CPI  3FH; '?'
        RM;  ?
        CPI  80H
        RP; 'A'p. 
PUTCMD:
        MOV  B,A;  p..
        MOV  A,C
        CPI  06H
        JZ   NXTSYM
        MOV  A,B
        STAX D
        INX  D
        INR  C
NXTSYM:
        INX  H
        MOV  A,M; ..p p
        CPI  30H; '0'
        JM   MIMO20
        CPI  3AH; ':'
        INX  H
        RZ
        DCX  H
        JM   PUTCMD
        JMP  TSTLAT
MIMO20:
        MOV  A,M
        CPI  20H
        RNZ
        INX  H
        JMP  MIMO20
K6E:
        CALL K77
        LDA  FLG
        DCR  A
        JNZ  K75
        CMP  C
        JNZ  K6F
        LDA  KEY
        DCR  A
        JZ   K72
        MVI  A,0FFH
        MOV  M,A
        INX  H
        MOV  M,A
        RET
K6F:
        LXI  D,CMD
        MVI  C,06H
K70:
        LDAX D
        MOV  M,A
        INX  D
        INX  H
        DCR  C
        JNZ  K70
        CALL K73
        INX  H
        XRA  A
        STA  BA2
        MOV  M,A
        SHLD ELN
        XCHG
        CALL HIM
        XCHG
TSTMEM:
        CALL CMHLDE
        RC
        LXI  H,KB4; '  '
        CALL LNS
        JMP  STR
K72:
        LDA  BA2
        ORA  A
        RNZ
K73:
        SHLD BDE
        PUSH H
        LHLD FIN
        XCHG
        LHLD BRG
        DAD  D
        XCHG
        POP  H
        MOV  M,E
        INX  H
        MOV  M,D
        RET
CMHLDE:
        MOV  A,H
        CMP  D
        RNZ
        MOV  A,L
        CMP  E
        RET
K75:
        MOV  C,M
        INX  H
        MOV  B,M
        CMP  B
        RNZ
        CMP  C
        JZ   SETER1

        DCR  A
        CMP  C
        JZ   SETER2
        RET
K76:
        CALL K77
        JM   SETER2
        MOV  E,M
        INX  H
        MOV  D,M
        RET
K77:
        LHLD BHL
K78:
        MVI  C,06H
        MOV  A,M
        DCR  A
        RM
        PUSH H
        LXI  D,CMD
K79:
        LDAX D
        CMP  M
        JZ   K7A
        POP  H
        LXI  B,0008H
        DAD  B
        JMP  K78
K7A:
        INX  D
        INX  H
        DCR  C
        JNZ  K79
        POP  D
        RET
K7B:
        MOV  A,M
        CPI  2CH; ','
        JNZ  K62
        INX  H
        CALL ANLARG
        LDA  OFS
        CPI  03H
        JZ   K7C
        DCR  C
K7C:
        DCR  C
        JNZ  K62
        RET
ANLARG:
        CALL TO_CMD
        XRA  A
        STA  ZNK
        STA  RGN
        STA  RG8
        CMP  C
        JZ   K7F
        CALL ANAREG
        CPI  01H;  pp
        JNZ  K7E
        MOV  C,A
        CALL K84
        RZ
        JC   K62
K7E:
        PUSH H
        CALL K76
        JMP  K83
K7F:
        CALL K84
        RZ
        CPI  2BH; '+'
        JZ   K80
        CPI  2DH; '-'
        JNZ  K81
K80:
        STA  ZNK
        INX  H
K81:
        CALL K8A
        INR  C
        JZ   K62
        LDA  ZNK
        CPI  2DH; '-'
        JNZ  K82
        XRA  A
        SUB  E
        MOV  E,A
        MVI  A,00H
        SBB  D
        MOV  D,A
K82:
        PUSH H
K83:
        LHLD RGN
        DAD  D
        SHLD RGN
        POP  H

        CALL K8A
        INR  C
        JNZ  K62
        MVI  C,02H
        JMP  K7F
K84:
        MOV  A,M
        ORA  A;    0
        RZ
        CPI  2CH; ','
        RZ
        CPI  3BH; '?'
        RZ
        STC
        RET
ANAREG:
        PUSH H
        LXI  H,TB1; pp A,B,C,D,E,F,SP,PSW
        MOV  B,C
K86:
        LXI  D,CMD; 1-  
        MOV  C,B
        MOV  A,M; <-TB1 -  
        INX  H; -->  pp
        ORA  A
        JZ   STBYTE; A=0 -   
        CMP  C
        JZ   K88; C = A   
        MOV  C,A
HLUPC:
        INX  H;    TB1
        DCR  C; <-TB1+1 C p
        JNZ  HLUPC;    
        INX  H; -->  pp
        JMP  K86;  pp 
K88:
        LDAX D; 1-  
        INX  D; 2-  
        CMP  M; 1-   =  pp ?
        JNZ  HLUPC;    TB1
        INX  H; = R
        DCR  C
        JNZ  K88
        MOV  A,M; A = R
        STA  RGN
        RLC; * 2
        RLC; * 4
        RLC; * 8
        STA  RG8
        MVI  A,01H;  pp
;                    -  
STBYTE:
        POP  H
        RET
K8A:
        CALL TO_CMD
        DCR  C
        JP   K95
        MOV  A,M
        CPI  27H; [']
        JZ   K92
        CPI  24H; '$'
        JZ   K96
        CPI  30H; '0'
        RM
        CPI  3AH; ':'
        RP
        LXI  D,CMD
        MVI  C,00H
K8B:
        SUI  30H
        STAX D
        INX  D
        INX  H
        MOV  A,M
        CPI  30H; '0'
        JM   K8C
        CPI  3AH; ':'
        JM   K8B
        CPI  41H; 'A'
        JM   K8C
        INR  C
        CPI  48H; 'H'
        JZ   K8D
        CPI  4AH; 'J'
        JP   K62
        SUI  07H
        JMP  K8B
K8C:
        XRA  A
        CMP  C
        JNZ  K62
        MVI  A,19H; ''
        JMP  K8E
K8D:
        INX  H
        MVI  A,29H; ')'
K8E:
        STAX D
        PUSH H
        LXI  H,CMD
        LXI  D,BEG
        SBI  19H; = 10H
K8F:
        MOV  B,A
        MOV  A,M
        INX  H
        CPI  10H; A=10H?
        JP   K97
        MOV  C,A
        MOV  A,B
        ORA  A
        MVI  B,00H
        PUSH H
        MOV  H,D
        MOV  L,E
        DAD  H
        DAD  H
        JNZ  K90
        DAD  D
        JMP  K91
K90:
        DAD  H
K91:
        DAD  H
        DAD  B
        XCHG
        POP  H
        JMP  K8F
K92:
        MVI  C,02H
        LDA  OFS
        CPI  0EH
        JNZ  GETDE
        POP  PSW
        RET
GETDE:
        INX  H
        MOV  E,M
        INX  H
        MOV  D,M
K94:
        MOV  A,M
        INX  H
        ORA  A; = 0 ?
        JZ   K62
        CPI  27H; [']
        JNZ  K94
        RET
K95:
        INR  C
        CALL ANAREG
        CPI  01H
        JZ   K62;  pp
        PUSH H
        CALL K76
        JMP  K97
K96:
        INX  H
        PUSH H
        LHLD BFN
        XCHG; DE = [BFN]
        LHLD BRG;= [BRG]
        DAD  D;HL= [BRG]+[BFN]
        XCHG; DE = [BRG]+[BFN]
K97:
        POP  H
        MVI  C,02H;  2   KOP
        RET
ANACOD:
        LDA  CM4;   STAX
        CPI  58H;     'X'
        JNZ  K99
        STA  CM3;   LDAX=LDX, STAX=STX ?
K99:
        LDA  CMD;   1-   (ADD-pp)
        SUI  41H;   'A'=0, 'B'=1...
        JM   LESS40;  A

        MOV  E,A;    p   'A' = 0
        MVI  D,00H;   pp  1 
        LXI  H,TB2;   2 = 0F6A9H
        DAD  D;       p 
        MOV  E,M;       -  E
        INX  H;         .
        MOV  A,M;       -  A
        SUB  E;      A-E=A -  pp
;                     p 
        JZ  LESS40; A=E - JMP p = 0 =>
;                    pp 
        MOV  C,A;    C=A-E p (.-p.)

        PUSH B;     [BC]-p p
        LXI  H,TB3;   3 = 0F6C5H
        DAD  D;         3*E ->
        DAD  D;     p  pp
        DAD  D;      
;
        MVI  C,20H
        LDA  CM2;   CMD+1 (p  CMD)
        SUB  C;     CMD+1-20H
        JZ   K9A;   p  CMD = 20H
        SUB  C;     CMD+1-40H
        JM   LESS40; < 40H - p  
K9A:;___  DE 
        RLC; *2 - p CMD+1-40H 
        RLC; *4
        RLC; *8
        MOV  B,A;  (CMD+1-40H)*8, D=4: 20H 0010.0000b

        LDA  CM3;   CMD+2 (p  CMD)
        SUB  C;     CMD+2-20H
        JZ   K9B;    CMD = 20H

        SUB  C;     CMD+2-40
        JM   LESS40; < 40H - p  
K9B:
        RRC; A/2 - p CMD+2-40H p
        RRC; A/4
        MOV  C,A;  (CMD+2-40H)/4, D=4: 01H 0000.0001b
        ANI  07H;  0000.0111b
        ORA  B;                   D=4: 21H
        MOV  D,A;  D = 21H
        MOV  A,C;  A = 01H
        ANI  0C0H; 1100.0000b
        MOV  E,A;   DE  = 2101H
        POP  B;    [BC]- p
LOOKDE:
        MOV  A,M;   3
        INX  H;    
        CMP  D;   p [D]
        JNZ  UPINT3
        MOV  A,M; .  3
        ANI  0C0H;  2 . 1100.0000b
        CMP  E;    [C]
        JZ   K9F
UPINT3:
        INX  H
        INX  H
        DCR  C; -1    
        JNZ  LOOKDE
LESS40:
        MVI  B,04H
        JMP  K47
K9F:;___ 2    3
        MOV  A,M; p 2-  p TB3
        ANI  3FH;  6 . - 0011.1111b
        STA  OFS; p   TB0   p
        INX  H
        MOV  A,M;   3- 
        STA  KOP;   p
        RET
KA0:
        LDA  FLG
        DCR  A
        RZ
        LDA  CER
        ORA  A
        JNZ  KA2

        LDA  BA2
        ORA  A
        JNZ  KA1

        LDA  KEY
        ORA  A
        RNZ
KA1:
        LDA  CER
        ORA  A
KA2:
        PUSH PSW
        CALL PSSCR
        POP  PSW

        CNZ  HEK;  CER  = 0
        MVI  C,2AH; '*'
        CNZ  SCR

        LXI  D,SBF
        LDAX D
        CPI  3BH;   ';'
        LXI  B,1120H; NSP
        JZ   KA3
        XRA  A;      0
        STA  ZNK
        PUSH D
        CALL KA5
        POP  D
KA3:
        XCHG
        CALL SPB; B * ' '(Space)
        CALL LNS
KA4:
        LDA  ZNK
        ORA  A
        RZ
        XRA  A
        CALL PSSCR
        CALL KA5
        JMP  KA4
KA5:
        LDA  OFS
        CPI  0CH;
        RZ
        CPI  0DH;
        RZ
        CPI  11H;
        JZ   KAA

        LHLD BFN

        PUSH PSW
        XCHG; DE = BFN
        LHLD BRG
        DAD  D; HL = BRG+BFN
        CALL HLHEX
        XCHG;   DE = BRG+BFN
        POP  PSW
;               HL = BFN
        CPI  10H; A=OFS
        JZ   DISPHL
        MVI  B,04H
KA6:
        LDA  FIN
        SUB  L
        JZ   KA7
        MOV  A,M
        INX  H
        CALL HEK
        CALL SCR
        DCR  B
        JNZ  KA6
        LDA  FIN
        SUB  L
        SHLD BFN
KA7:
        STA  ZNK
        MOV  A,B
        RLC; = 2*A
        ADD  B;3*A
        MOV  B,A
        RET
DISPHL:
        MVI  C,28H; '('
        CALL SCR
        MVI  C,20H; ' '
        CALL SCR
        LHLD RGN
        CALL HLHEX;   '[H][L]'
        MVI  A,29H; ')'
        CALL SCA
        MVI  B,04H
        RET
HEK:
        PUSH PSW
        PUSH B
        CALL HEX
        POP  B
        POP  PSW
        RET
KAA:
        XCHG
        CALL TO_CMD
        CALL K76
        XCHG
        MVI  B,0CH
HLHEX:
        MOV  A,H
        CALL HEK
        MOV  A,L
        CALL HEK
        JMP  SCR; C -> p.

TB0:;__0F663H____  p  
;________________  - TBFUNK
        DB   0BH;
        DB   00H;  

        DB   08H;
        DB   01H;  pp

        DB   2EH;
        DB   01H;  pp

        DB   00H;
        DB   01H;  pp

        DB   16H;
        DB   02H;    KOP

        DB   0EH;
        DB   01H;  pp

        DB   26H;
        DB   02H;    KOP

        DB   2BH;
        DB   01H;  pp

        DB   31H;
        DB   01H;  pp

        DB   37H;
        DB   01H;  pp

        DB   1BH;
        DB   01H;  pp

        DB   3DH;
        DB   02H;    KOP

        DB   0C1H;
        DB   02H;    KOP

        DB   0D8H; 0D9H ?
        DB   00H;  

        DB   82H;
        DB   02H;    KOP

        DB   82H;
        DB   02H;    KOP

        DB   4DH;
        DB   02H;    KOP

        DB   59H;
        DB   02H;    KOP

TB1:;__0F687H_____ p   xx+R
        DB   01H;-   pp
        DB   41H; 'A'
        DB   07H;= R

        DB   01H;-   pp
        DB   42H; 'B'
        DB   00H;= R

        DB   01H;-   pp
        DB   43H; 'C'
        DB   01H;= R

        DB   01H;-   pp
        DB   44H; 'D'
        DB   02H;= R

        DB   01H;-   pp
        DB   45H; 'E'
        DB   03H;= R

        DB   01H;-   pp
        DB   48H; 'H'
        DB   04H;= R

        DB   01H;-   pp
        DB   4CH; 'L'
        DB   05H;= R

        DB   01H;-   pp
        DB   4DH; 'M'
        DB   06H;= R

        DB   02H;-   pp
        DB   53H; 'S'
        DB   50H; 'P'
        DB   08H;

        DB   03H;-   pp
        DB   50H; 'P'
        DB   53H; 'S'
        DB   57H; 'W'
        DB   09H;

        DB   00H;  STOP_BYTE

TB2:;__0F6A9H____ 1    
;____________________   p D 
;____________________  (-p.):
        DB   00H; 1 A: D = 6 pp  A
        DB   06H; 2 B: D = 0 pp  B
        DB   06H; 3 C: D =13 pp  C
        DB   13H; 4 D
        DB   1BH; 5 E: D = 3 pp  E !!!
        DB   1EH; 6 F
        DB   1EH; 7 G
        DB   1EH; 8 H
        DB   1FH; 9 I
        DB   22H;10 J  D =10 pp  J
        DB   2CH; 1 K
        DB   2CH; 2 L
        DB   30H; 3 M
        DB   32H; 4 N
        DB   33H; 5 O: D = 4 pp  O-ORG!!!
        DB   37H; 6 P
        DB   3AH; 7 Q
        DB   3AH; 8 R
        DB   48H; 9 S
        DB   51H;20 T: D = 0 pp  T
        DB   51H; 1 U: D = 0 pp  U
        DB   51H; 2 V: D = 0 pp  V
        DB   51H; 3 W: D = 0 pp  W
        DB   51H; 4 X: D = 4 pp  X
        DB   55H; 5 Y: D = 0 pp  Y
        DB   55H; 6 Z: D = 0 pp  Z
        DB   55H; 7 - p  Z

TB3:;__0F6C5H_____   
;                    p p  TB2
;  6  p  p -   TB0
        DB   1AH, 44H, 0CEH; 1  ACI N0
        DB   20H, 0C1H, 88H; 2  ADC r  = 88+R
        DB   21H, 01H,  80H; 3  ADD R  = 80+R
        DB   22H, 44H, 0C6H; 4  ADI N0
        DB   70H, 41H, 0A0H; 5  ANA r  = A0+R
        DB   72H, 44H, 0E6H; 6  ANI N0

        DB   0BH, 06H, 0CDH; 7  CALL
        DB   18H, 06H, 0DCH; 8  CC
        DB   68H, 06H, 0FCH; 9  CM
        DB   68H, 40H, 2FH; 10  CMA
        DB   68H, 0C0H, 3FH; 1  CMC
        DB   6CH, 01H, 0B8H; 2  CMP r  = B8+R
        DB   70H, 0C6H, 0D4H;3  CNC
        DB   76H, 86H, 0C4H; 4  CNZ
        DB   80H, 06H, 0F4H; 5  CP
        DB   81H, 46H, 0ECH; 6  CPE
        DB   82H, 44H, 0FEH; 7  CPI N0
        DB   83H, 0C6H, 0E4H;8  CPO
        DB  0D0H, 06H, 0CCH; 9  CZ

        DB   08H, 40H, 27H; 20  DAA
        DB   09H, 07H, 09H;  1  DAD r  = 09+8R
        DB   1CH, 82H, 05H;  2  DCR r  = 05+8R
        DB   1EH, 07H, 0BH;  3  DCX r  = 0B+8R
        DB   48H, 00H, 0F3H; 4  DI
        DB   10H, 0EH, 00H;  5  DB
        DB   0B8H, 0FH, 00H; 6  DW
        DB   98H, 10H, 00H;  7  DS N

        DB   48H, 00H, 0FBH; 8  EI
        DB   71H, 0DH, 00H;  9  END
        DB   8DH, 51H, 00H; 30  EQU

        DB   65H, 00H, 76H;  1  HLT

        DB   70H, 04H, 0DBH; 2  IN N0
        DB   74H, 82H, 04H;  3  INR r = 04+8R
        DB   76H, 07H, 03H;  4  INX r = 03+8R

        DB   18H, 06H, 0DAH; 5  JC
        DB   68H, 06H, 0FAH; 6  JM
        DB   6CH, 06H, 0C3H; 7  JMP
        DB   00H, 06H, 0C3H; 8  ------???
        DB   70H, 0C6H, 0D2H;9  JNC
        DB   76H, 86H, 0C2H;40  JNZ
        DB   80H, 06H, 0F2H; 1  JP
        DB   81H, 46H, 0EAH; 2  JPE
        DB   83H, 0C6H, 0E2H;3  JPO
        DB  0D0H, 06H, 0CAH; 4  JZ

        DB   20H, 46H, 3AH;  5  LDA N0 N1
        DB   26H, 09H, 0AH;  6  LDAX r = 0A+8R
        DB   43H, 06H, 2AH;  7  LHLD N0 N1
        DB  0C2H, 4AH, 01H;  8  LXI r,N0 N1 = 01+8R

        DB  0B2H, 45H, 06H;  9  MVI r,N0
        DB   7DH, 83H, 40H; 50  MOV r1,r2 = 40+8R1+R2

        DB   7CH, 00H, 00H;  1  NOP

        DB   90H, 41H, 0B0H; 2  ORA r = B0+R
        DB   92H, 44H, 0F6H; 3  ORI N0
        DB  0ADH, 04H, 0D3H; 4  OUT N0
        DB   91H, 0CCH, 00H; 5  ORG !!!

        DB   1AH, 00H, 0E9H; 6  PCHL
        DB   7CH, 08H, 0C1H; 7  POP r  = C1+8R
        DB  0ACH, 0C8H, 0C5H;8  PUSH r = C5+8R

        DB   0BH, 00H, 17H;  9  RAL
        DB   0CH, 80H, 1FH; 60  RAR
        DB   60H, 0C0H, 07H; 1  RLC
        DB   90H, 0C0H, 0FH; 2  RRC
        DB   2DH, 00H, 0C9H; 3  RET
        DB   18H, 00H, 0D8H; 4  RC
        DB   70H, 0C0H, 0D0H;5  RNC
        DB  0D0H, 00H, 0C8H; 6  RZ
        DB   76H, 80H, 0C0H; 7  RNZ
        DB   80H, 00H, 0F0H; 8  RP
        DB   68H, 00H, 0F8H; 9  RM
        DB   81H, 40H, 0E8H;70  RM
        DB   83H, 0C0H, 0E0H;1  RPO
        DB   9DH, 0BH, 0C7H; 2  RST n = C7+8n

        DB   10H, 81H, 98H;  3  SBB r = 98+R
        DB   12H, 44H, 0DEH; 4  SBI N0
        DB   43H, 06H, 22H;  5  SHLD N0 N1
        DB   82H, 00H, 0F9H; 6  SPHL
        DB  0A0H, 46H, 32H;  7  STA N0 N1
        DB  0A6H, 09H, 02H;  8  STAX r = 02+8R
        DB  0A0H, 0C0H, 37H; 9  STC
        DB  0A8H, 81H, 90H; 80  SUB r = 90+R
        DB  0AAH, 44H, 0D6H; 1  SUI N0

        DB   1AH, 00H, 0EBH; 2  XCHG
        DB   90H, 41H, 0A8H; 3  XRA r = A8+R
        DB   92H, 44H, 0EEH; 4  XRI N0
        DB   0A2H, 00H, 0E3H;5  XTHL
;-------------------------- 85 -  pp
KB0:DB   'ERRORS:',00H
KB1:DB   8BH,90H,' ASSM_MX/4K: F1-LIST F2-'
LIN:DB   'LINK '
    DB   'F3-'
EXE:DB   'EXE',8CH,19H,0AH,' ',0FH,00H
KB4:DB   ' less RAM',00H

BEG:EQU  0000H

BHL:EQU  1050H

ERR:EQU  1052H
FLG:EQU  1053H
CER:EQU  1054H
FIN:EQU  1055H

BFN:EQU  1057H

OFS:EQU  1059H;   TB0
RGN:EQU  105AH; p pp
RG8:EQU  105BH; p pp * 8
KOP:EQU  105CH;  p
BDE:EQU  105DH; p p  DE

BBF:EQU  105FH

ZNK:EQU  1061H;   p
KEY:EQU  1062H;    F1-F3 (00H-02H)
PRZ:EQU  1063H
BRG:EQU  1064H

SBF:EQU  1066H; p p

CMD:EQU  10E6H; 1  
CM2:EQU  10E7H; 2
CM3:EQU  10E8H; 3
CM4:EQU  10E9H; 4

ELN:EQU  10F0H
BA2:EQU  10F2H

BUF:EQU  1100H
;NSP:EQU  1120H
;___ BIOS__
KBD:EQU  0C803H
SCR:EQU  0C809H
SCA:EQU  0C80FH
HEX:EQU  0C815H
LNS:EQU  0C818H
KLA:EQU  0C81BH
HIM:EQU  0C830H
FIL:EQU  0F824H
SAV:EQU  0F827H
EXT:EQU  0F82DH

STK:EQU  0D2FFH
EDT:EQU  0E806H

ZAK:EQU  0FFFCH
;ROM:EQU  0FFFEH
        end